/*
 * index.h: interface to Index class
 */

// note: the definition of this class is done completely in the header file;
// this means the 'isOK' code should be inlined - makes program faster but
// only works for small, simple functions that use private member variables

// this class makes allocating a 2D array unnecessary - which is good because
// they confuse me (I still think in Fortran style cols and rows).
// the operator () returns the offset into an 1D array where (i,j) is stored

class Index {
private:
  int ni;
  int nj;

public:
  Index() : ni(-1), nj(-1) {}
  Index(int _ni, int _nj) : ni(_ni), nj(_nj) {}
  ~Index() {}

  int size() { return ni*nj; }
  bool isOK(int i, int j) { return i>=0 && i<ni && j>=0 && j<nj; }
  int operator()(int i, int j) { return j*ni + i; }
};
